<%@ Language=VBScript        %>
<% Option Explicit           %>
<% Response.Buffer = True    %>
<% Response.Expires = 0      %>
<% Server.ScriptTimeout = 60 %>
<% Session.Timeout = 15      %>

<!--#include virtual=cADO.asp-->

<%


'=============================================================================================================
' The following variables can be passed to this ASP page via the "Request.QueryString" or "Request.Form"
' collections.  The "QueryString" collection is preferred if both are specified.
'
' Variables:        Use:
' ------------------------------------------------------------------------------------------------------------
' Debug             If set to "1" and an error occurs, a message box will be displayed to the user with the 
'                   error information
' Query             Specifies the SQL query string to submit to the database to get the information to work with
' Form              The name of the form that contains the ComboBox control being populated
' Combo             The name of the ComboBox within the specified Form to be populated
' TxtF              A pipe "|" delimited list of field names contained within the ADODB.Recordset object 
'                   returned from the specified SQL query string to be used to build the CAPTIONS of the
'                   ComboBox drop down items
' ValF              A pipe "|" delimited list of field names contained within the ADODB.Recordset object
'                   returned from the specified SQL query string to be used to build the VALUES of the 
'                   ComboBox drop down items
'
' Example:
' --------
' function FillDepartments() {
'    var lngStateID = document.MyForm.cboState.options[document.MyForm.cboState.selectedIndex].value;
'    var strURL    = "PopulateSelect.asp?Query=uspGetBranchesByState+" + lngStateID + "&Form=MyForm&Combo=cboBranches&TxtF=cBranchName&ValF=iBranchID|cBranchName&Debug=1"
'    window.open(strURL, "PopulateWindow", "scrollbars=yes,resizable=yes,HEIGHT=800,WIDTH=600,top=0,left=0");
'    document.MyForm.cboBranches.focus();
' }
'
'=============================================================================================================


' SET THE CONNECTION STRING HERE
Dim strConnString 'As String
strConnString = Application("ConnString") 

Dim mobjADO        'As cADO
Dim mobjRS         'As ADODB.Recordset
Dim mlngErrNum     'As Long
Dim mstrErrSrc     'As String
Dim mstrErrDesc    'As String
Dim mblnDebug      'As Boolean
Dim mastrFieldsT   'As String
Dim mintFieldsT    'As Integer
Dim mastrFieldsV   'As String
Dim mintFieldsV    'As Integer

Dim mstrIN_Query   'As String
Dim mstrIN_Combo   'As String
Dim mstrIN_Form    'As String
Dim mstrIN_FieldsT 'As String
Dim mstrIN_FieldsV 'As String

' Set default variable values
Set mobjADO = Nothing
Set mobjRS  = Nothing
mlngErrNum  = 0
mstrErrDesc = ""
mstrErrSrc  = ""
mblnDebug   = False

' Start here
If Form_Load = True Then
   Call Form_Activate
   Call Form_Unload 
Else
   Response.Clear 
   Response.Write "<HTML>"                              & vbCrLf
   Response.Write "<HEAD>"                              & vbCrLf
   Response.Write "</HEAD>"                             & vbCrLf
   Response.Write "<BODY>"                              & vbCrLf
   If mblnDebug = True Then
      Response.Write "<SCRIPT LANGUAGE=""JavaScript"">" & vbCrLf
      Response.Write "<!--"                             & vbCrLf
      Response.Write "  alert('The following error occured while trying to get the departments for the selected business line:\n\nError Number = &H" & CStr(HEX(mlngErrNum)) & "\nError Source = " & Replace(mstrErrSrc, "'", "\'") & "\nError Description = " & Replace(mstrErrDesc, "'", "\'") & "');" & vbCrLf
      Response.Write "//-->"                            & vbCrLf
      Response.Write "</SCRIPT>"                        & vbCrLf
   End If
   Call Form_Unload
End If

Response.End 

'_____________________________________________________________________________________________________________

Function Form_Load() 'As Boolean
On Error Resume Next
   
   Form_Load = False
   
   ' Get the values passed to this ASP page
   mblnDebug = CBool(Trim(Request.QueryString("Debug")) = "1" Or Trim(Request.Form("Debug")) = "1")
   mstrIN_Query = Trim(Request.QueryString("Query"))
   If mstrIN_Query = "" Then mstrIN_Query = Trim(Request.Form("Query"))
   mstrIN_Form = Trim(Request.QueryString("Form"))
   If mstrIN_Form = "" Then mstrIN_Form = Trim(Request.Form("Form"))
   mstrIN_Combo = Trim(Request.QueryString("Combo"))
   If mstrIN_Combo = "" Then mstrIN_Combo = Trim(Request.Form("Combo"))
   mstrIN_FieldsT = Trim(Request.QueryString("TxtF"))
   If mstrIN_FieldsT = "" Then mstrIN_FieldsT = Trim(Request.Form("TxtF"))
   mstrIN_FieldsV = Trim(Request.QueryString("ValF"))
   If mstrIN_FieldsV = "" Then mstrIN_FieldsV = Trim(Request.Form("ValF"))
   
   ' Validate passed values
   If mstrIN_Query = "" Or mstrIN_Form = "" Or mstrIN_Combo = "" Or mstrIN_FieldsT = "" Or mstrIN_FieldsV = "" Then
      mlngErrNum = CLng(-1)
      mstrErrSrc = "Form_Load()"
      mstrErrDesc = "Required parameter(s) are invalid or missing."
      Exit Function
   End If
   
   ' Get the fields from the passed in string
   If InStr(1, mstrIN_FieldsT, "|") = 0 Then
      ReDim mastrFieldsT(0) 'As String
      mintFieldsT = 0
      mastrFieldsT(0) = mstrIN_FieldsT
   Else
      mastrFieldsT = Split(mstrIN_FieldsT, "|")
      mintFieldsT = UBound(mastrFieldsT)
   End If
   If InStr(1, mstrIN_FieldsV, "|") = 0 Then
      ReDim mastrFieldsV(0) 'As String
      mintFieldsV = 0
      mastrFieldsV(0) = mstrIN_FieldsV
   Else
      mastrFieldsV = Split(mstrIN_FieldsV, "|")
      mintFieldsV = UBound(mastrFieldsV)
   End If
   
   ' Setup the cADO class and connect to the database
   Set mobjADO = New cADO
   If CheckError(Err.number, Err.Description, mlngErrNum, mstrErrDesc) = True Then 
      mstrErrSrc = "Set mobjADO = New cADO"
      Exit Function
   End If
   
   ' Connect to the database
   If mobjADO.SetConnectionString(strConnString, mlngErrNum, mstrErrDesc) = False Then 
      mstrErrSrc = "If mobjADO.SetConnectionString(..)"
      Exit Function
   End If
   
   ' Get the departments from the database
   If mobjADO.ExecuteSQL(mstrIN_Query, True, adUseClient, adOpenForwardOnly, adLockReadOnly, -1, -1, mlngErrNum, mstrErrDesc, mobjRS, True, False, 1, True) = False Then
      mstrErrSrc = "mobjADO.ExecuteSQL(..)"
   Else
      Form_Load = True
   End If
   
End Function

'_____________________________________________________________________________________________________________

Sub Form_Unload()
On Error Resume Next
   
   mobjADO.CleanupRecordset mobjRS, True
   Set mobjADO = Nothing
   
   Response.Write "<SCRIPT LANGUAGE=""JavaScript"">" & vbCrLf
   Response.Write "   <!--"                          & vbCrLf
   Response.Write "   window.close();"               & vbCrLf
   Response.Write "   //-->"                         & vbCrLf
   Response.Write "</SCRIPT>"                        & vbCrLf
   Response.Write "</BODY>" & vbCrLf & "</HTML>"     & vbCrLf
   
End Sub

'_____________________________________________________________________________________________________________

Sub Form_Activate()
   
   Dim strText    'As String
   Dim strValue   'As String
   Dim intCounter 'As Integer
   
%>

<HTML>
<HEAD>
<TITLE>Querying Database...</TITLE>
</HEAD>

<SCRIPT LANGUAGE="JavaScript">
<!--
   var iCount = 0;
   
   function AddItem(strText, strValue) {
      iCount = iCount + 1;
      top.opener.document.<%= mstrIN_Form & "." & mstrIN_Combo %>.length = iCount;
      top.opener.document.<%= mstrIN_Form & "." & mstrIN_Combo %>.options[iCount - 1].value = strValue;
      top.opener.document.<%= mstrIN_Form & "." & mstrIN_Combo %>.options[iCount - 1].text = strText;
   }
   
   function RemoveItem() {
      if (iCount >= 0) {
         iCount = iCount - 1;
         top.opener.document.<%= mstrIN_Form & "." & mstrIN_Combo %>.options.length = iCount;
      }
   }
   
   function ClearItems() {
      iCount = 0;
      top.opener.document.<%= mstrIN_Form & "." & mstrIN_Combo %>.options.length = 0;
   }
//-->
</SCRIPT>

<BODY bgcolor="#C0C0C0">

<B>Querying database for information... please wait.</B>

<% 
   Response.Write "<SCRIPT LANGUAGE=""JavaScript"">" & vbCrLf
   Response.Write "  <!--"                           & vbCrLf
   Response.Write "  ClearItems();"                  & vbCrLf
   Response.Write "  AddItem('- SELECT ONE -', '');" & vbCrLf
   
   If Not mobjRS Is Nothing Then
      Do While mobjRS.EOF = False
         
         ' Clear the string values
         strText = ""
         strValue = ""
         
         ' Loop through and get the captions needed
         For intCounter = 0 To mintFieldsT
            strText = strText & Trim(mobjRS(mastrFieldsT(intCounter)) & "") & ","
         Next
         
         ' Loop through and get the values needed
         For intCounter = 0 To mintFieldsV
            strValue = strValue & Trim(mobjRS(mastrFieldsV(intCounter)) & "") & ","
         Next
         
         ' Make sure there are no illegal characters being passed
         If Right(strText, 1) = "," Then strText = Left(strText, Len(strText) - 1)
         If Right(strValue, 1) = "," Then strValue = Left(strValue, Len(strValue) - 1)
         strText = Replace(strText, "'", "\'")
         strValue = Replace(strValue, "'", "\'")
         
         ' Write out the JavaScript function call
         Response.Write "  AddItem('" & strText & "', '" & strValue & "');" & vbCrLf
			
			' Move to the next variable
			mobjRS.MoveNext
      Loop
   End If
   
   Response.Write "  //-->"                          & vbCrLf
   Response.Write "</SCRIPT>"                        & vbCrLf
   
End Sub
%>
